'####################################################################################################################
'*******************ArcGIS_SLD_Converter / Rel. 1.2.0****************************************************************
'*******************Class: Motherform********************************************************************************
'*******************AUTHOR: Albrecht Weiser, University of applied Sciences in Mainz, Germany 2005*******************
'The Application was part of my Diploma thesis:**********************************************************************
'"Transforming map-properties of maps in esri-data to an OGC-conformous SLD-document, for publishing the ArcGIS-map * 
'with an OGC- conformous map-server"*********************************************************************************
'ABSTRACT:
'The program so called "ArcGIS-map to SLD Converter" analyses an
'ArcMap-Project with respect to its symbolisation and assembles an SLD
'for the OGC-Web Map Service (WMS) from the gathered data. The program
'is started parallel to a running ArcMap 9.X-session. Subsequently the
'application deposits an SLD-file which complies the symbolisation of
'the available ArcMap-project. With the SLD a WMS-project may be
'classified and styled according to the preceding ArcMap-project. The
'application is written in VisualBasic.NET and uses the .NET 1.1
'Framework (plus XML files for configuration). For more informtion
'refer to: 
'http://arcmap2sld.geoinform.fh-mainz.de/ArcMap2SLDConverter_Eng.htm.
'LICENSE:
'This program is free software under the license of the GNU Lesser General Public License (LGPL) As published by the Free Software Foundation. 
'With the use and further development of this code you accept the terms of LGPL. For questions of the License refer to:
'http://www.gnu.org/licenses/lgpl.html
'DISCLAIMER:
'THE USE OF THE SOFTWARE ArcGIS-map to SLD Converter HAPPENS AT OWN RISK.
'I CANNOT ISSUE A GUARANTEE FOR ANY DISADVANTAGES (INCLUDING LOSS OF DATA; ETC.) THAT
'MAY ARISE FROM USING THIS SOFTWARE.
'DESCRIPTION:
'The Button1 triggers the analysis of the ArcMap symbols of the class "Analize_ArcMap_Symbols"
'CHANGES:
'04.02.2006: Language-customizing english/german
'04.02.2006: Tooltips
'28.02.2007: Small code cleanup in using constants.
'25.04.2007: Added option to menu to enable or disable checking all layers (or just selected layers).
'####################################################################################################################

Imports System
Imports System.Xml
Imports System.Text
Imports System.IO

Public Class Motherform
    Inherits System.Windows.Forms.Form


#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()
        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        m_bLabel = False
        m_bTooltip = False
        m_bAllLayers = True
        m_enumLang = Language.Deutsch
        SetSizeOpen()
        InitCommonXML()
        InitControlNameVariables()
        Preconfigure()
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents dlgSave As System.Windows.Forms.SaveFileDialog
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents txtFileName As System.Windows.Forms.TextBox
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents chkArcIMS As System.Windows.Forms.RadioButton
    Friend WithEvents chkUMN As System.Windows.Forms.RadioButton
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents lblTop As System.Windows.Forms.Label
    Friend WithEvents lblBottom As System.Windows.Forms.Label
    Friend WithEvents lblSmall As System.Windows.Forms.Label
    Friend WithEvents chkValidate As System.Windows.Forms.CheckBox
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents txtSLDxsd As System.Windows.Forms.TextBox
    Friend WithEvents cboLowScale As System.Windows.Forms.ComboBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents OpenXSD As System.Windows.Forms.OpenFileDialog
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents cboHighScale As System.Windows.Forms.ComboBox
    Friend WithEvents chkScale As System.Windows.Forms.CheckBox
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem7 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem8 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem9 As System.Windows.Forms.MenuItem
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Motherform))
        Me.Button1 = New System.Windows.Forms.Button
        Me.Button2 = New System.Windows.Forms.Button
        Me.txtFileName = New System.Windows.Forms.TextBox
        Me.dlgSave = New System.Windows.Forms.SaveFileDialog
        Me.Label3 = New System.Windows.Forms.Label
        Me.OpenXSD = New System.Windows.Forms.OpenFileDialog
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.chkUMN = New System.Windows.Forms.RadioButton
        Me.chkArcIMS = New System.Windows.Forms.RadioButton
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.lblSmall = New System.Windows.Forms.Label
        Me.lblBottom = New System.Windows.Forms.Label
        Me.lblTop = New System.Windows.Forms.Label
        Me.chkValidate = New System.Windows.Forms.CheckBox
        Me.GroupBox3 = New System.Windows.Forms.GroupBox
        Me.Label6 = New System.Windows.Forms.Label
        Me.chkScale = New System.Windows.Forms.CheckBox
        Me.Label5 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.cboHighScale = New System.Windows.Forms.ComboBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.cboLowScale = New System.Windows.Forms.ComboBox
        Me.txtSLDxsd = New System.Windows.Forms.TextBox
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.MenuItem7 = New System.Windows.Forms.MenuItem
        Me.MenuItem8 = New System.Windows.Forms.MenuItem
        Me.MenuItem9 = New System.Windows.Forms.MenuItem
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.GroupBox3.SuspendLayout()
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.BackColor = System.Drawing.Color.MidnightBlue
        Me.Button1.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Button1.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.Button1.Location = New System.Drawing.Point(8, 168)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(96, 24)
        Me.Button1.TabIndex = 0
        Me.Button1.Text = "SLD"
        '
        'Button2
        '
        Me.Button2.BackColor = System.Drawing.Color.MidnightBlue
        Me.Button2.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.Button2.Location = New System.Drawing.Point(96, 18)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(18, 18)
        Me.Button2.TabIndex = 1
        Me.Button2.Text = ".."
        '
        'txtFileName
        '
        Me.txtFileName.Location = New System.Drawing.Point(120, 16)
        Me.txtFileName.Name = "txtFileName"
        Me.txtFileName.Size = New System.Drawing.Size(288, 20)
        Me.txtFileName.TabIndex = 2
        Me.txtFileName.Text = ""
        '
        'Label3
        '
        Me.Label3.BackColor = System.Drawing.Color.Transparent
        Me.Label3.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.Label3.Location = New System.Drawing.Point(8, 20)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(88, 16)
        Me.Label3.TabIndex = 5
        Me.Label3.Text = "SLD Speicherort"
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.BottomLeft
        '
        'GroupBox1
        '
        Me.GroupBox1.BackColor = System.Drawing.Color.Transparent
        Me.GroupBox1.Controls.Add(Me.chkUMN)
        Me.GroupBox1.Controls.Add(Me.chkArcIMS)
        Me.GroupBox1.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.GroupBox1.Location = New System.Drawing.Point(8, 48)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(96, 80)
        Me.GroupBox1.TabIndex = 9
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Serverdaten"
        '
        'chkUMN
        '
        Me.chkUMN.Checked = True
        Me.chkUMN.Location = New System.Drawing.Point(8, 48)
        Me.chkUMN.Name = "chkUMN"
        Me.chkUMN.Size = New System.Drawing.Size(72, 16)
        Me.chkUMN.TabIndex = 1
        Me.chkUMN.TabStop = True
        Me.chkUMN.Text = "Shapefile"
        '
        'chkArcIMS
        '
        Me.chkArcIMS.Location = New System.Drawing.Point(8, 24)
        Me.chkArcIMS.Name = "chkArcIMS"
        Me.chkArcIMS.Size = New System.Drawing.Size(72, 16)
        Me.chkArcIMS.TabIndex = 0
        Me.chkArcIMS.Text = "ArcSDE"
        '
        'GroupBox2
        '
        Me.GroupBox2.BackColor = System.Drawing.Color.Transparent
        Me.GroupBox2.Controls.Add(Me.lblSmall)
        Me.GroupBox2.Controls.Add(Me.lblBottom)
        Me.GroupBox2.Controls.Add(Me.lblTop)
        Me.GroupBox2.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.GroupBox2.Location = New System.Drawing.Point(120, 168)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(288, 96)
        Me.GroupBox2.TabIndex = 10
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Infofeld"
        '
        'lblSmall
        '
        Me.lblSmall.BackColor = System.Drawing.Color.Transparent
        Me.lblSmall.Location = New System.Drawing.Point(8, 72)
        Me.lblSmall.Name = "lblSmall"
        Me.lblSmall.Size = New System.Drawing.Size(272, 16)
        Me.lblSmall.TabIndex = 2
        '
        'lblBottom
        '
        Me.lblBottom.BackColor = System.Drawing.Color.Transparent
        Me.lblBottom.Location = New System.Drawing.Point(8, 40)
        Me.lblBottom.Name = "lblBottom"
        Me.lblBottom.Size = New System.Drawing.Size(272, 32)
        Me.lblBottom.TabIndex = 1
        '
        'lblTop
        '
        Me.lblTop.BackColor = System.Drawing.Color.Transparent
        Me.lblTop.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTop.Location = New System.Drawing.Point(8, 16)
        Me.lblTop.Name = "lblTop"
        Me.lblTop.Size = New System.Drawing.Size(272, 24)
        Me.lblTop.TabIndex = 0
        '
        'chkValidate
        '
        Me.chkValidate.BackColor = System.Drawing.Color.Transparent
        Me.chkValidate.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.chkValidate.Location = New System.Drawing.Point(8, 136)
        Me.chkValidate.Name = "chkValidate"
        Me.chkValidate.Size = New System.Drawing.Size(120, 24)
        Me.chkValidate.TabIndex = 11
        Me.chkValidate.Text = "SLD-Validierung"
        '
        'GroupBox3
        '
        Me.GroupBox3.BackColor = System.Drawing.Color.Transparent
        Me.GroupBox3.Controls.Add(Me.Label6)
        Me.GroupBox3.Controls.Add(Me.chkScale)
        Me.GroupBox3.Controls.Add(Me.Label5)
        Me.GroupBox3.Controls.Add(Me.Label4)
        Me.GroupBox3.Controls.Add(Me.Label2)
        Me.GroupBox3.Controls.Add(Me.cboHighScale)
        Me.GroupBox3.Controls.Add(Me.Label1)
        Me.GroupBox3.Controls.Add(Me.cboLowScale)
        Me.GroupBox3.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
        Me.GroupBox3.Location = New System.Drawing.Point(120, 48)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(288, 80)
        Me.GroupBox3.TabIndex = 12
        Me.GroupBox3.TabStop = False
        Me.GroupBox3.Text = "Darstellungsbereich"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(16, 24)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(48, 16)
        Me.Label6.TabIndex = 7
        Me.Label6.Text = "in SLD?"
        '
        'chkScale
        '
        Me.chkScale.Location = New System.Drawing.Point(16, 48)
        Me.chkScale.Name = "chkScale"
        Me.chkScale.Size = New System.Drawing.Size(48, 24)
        Me.chkScale.TabIndex = 6
        Me.chkScale.Text = "O.K."
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(192, 24)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(88, 16)
        Me.Label5.TabIndex = 5
        Me.Label5.Text = "Kleiner Mastab"
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(80, 24)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(88, 16)
        Me.Label4.TabIndex = 4
        Me.Label4.Text = "Groer Mastab"
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(176, 52)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(16, 16)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "1:"
        '
        'cboHighScale
        '
        Me.cboHighScale.Location = New System.Drawing.Point(192, 48)
        Me.cboHighScale.Name = "cboHighScale"
        Me.cboHighScale.Size = New System.Drawing.Size(80, 21)
        Me.cboHighScale.TabIndex = 2
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(64, 52)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(16, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "1:"
        '
        'cboLowScale
        '
        Me.cboLowScale.Location = New System.Drawing.Point(80, 48)
        Me.cboLowScale.Name = "cboLowScale"
        Me.cboLowScale.Size = New System.Drawing.Size(80, 21)
        Me.cboLowScale.TabIndex = 0
        '
        'txtSLDxsd
        '
        Me.txtSLDxsd.Location = New System.Drawing.Point(120, 136)
        Me.txtSLDxsd.Name = "txtSLDxsd"
        Me.txtSLDxsd.Size = New System.Drawing.Size(288, 20)
        Me.txtSLDxsd.TabIndex = 13
        Me.txtSLDxsd.Text = ""
        Me.txtSLDxsd.Visible = False
        '
        'PictureBox1
        '
        Me.PictureBox1.BackColor = System.Drawing.Color.Transparent
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
        Me.PictureBox1.Location = New System.Drawing.Point(40, 216)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(32, 32)
        Me.PictureBox1.TabIndex = 15
        Me.PictureBox1.TabStop = False
        '
        'ImageList1
        '
        Me.ImageList1.ImageSize = New System.Drawing.Size(32, 32)
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem2, Me.MenuItem5, Me.MenuItem7})
        Me.MenuItem1.Text = "Extras"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 0
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem3, Me.MenuItem4})
        Me.MenuItem2.Text = "Sprache/Language"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 0
        Me.MenuItem3.Text = "Deutsch"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 1
        Me.MenuItem4.Text = "English"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 1
        Me.MenuItem5.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem6})
        Me.MenuItem5.Text = "Tooltips"
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 0
        Me.MenuItem6.Text = "ein/on"
        '
        'MenuItem7
        '
        Me.MenuItem7.Index = 2
        Me.MenuItem7.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem8, Me.MenuItem9})
        Me.MenuItem7.Text = "Layers"
        '
        'MenuItem8
        '
        Me.MenuItem8.Checked = True
        Me.MenuItem8.Index = 0
        Me.MenuItem8.RadioCheck = True
        Me.MenuItem8.Text = "Alle/All Layers"
        '
        'MenuItem9
        '
        Me.MenuItem9.Index = 1
        Me.MenuItem9.RadioCheck = True
        Me.MenuItem9.Text = "Ausgewhlte/Selected Layers"
        '
        'ToolTip1
        '
        Me.ToolTip1.Active = False
        '
        'Motherform
        '
        Me.AutoScale = False
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.SteelBlue
        Me.ClientSize = New System.Drawing.Size(418, 275)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.txtSLDxsd)
        Me.Controls.Add(Me.GroupBox3)
        Me.Controls.Add(Me.chkValidate)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.txtFileName)
        Me.Controls.Add(Me.Button2)
        Me.Controls.Add(Me.Button1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Menu = Me.MainMenu1
        Me.Name = "Motherform"
        Me.Text = "  ArcGIS-map to SLD Converter"
        Me.TopMost = True
        Me.TransparencyKey = System.Drawing.Color.Brown
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.GroupBox3.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    '##################################################################################################
    '######################################## DEKLARATIONEN ###########################################
    '##################################################################################################
#Region "Membervariablen"
    Private AnalizeArcMap As Analize_ArcMap_Symbols 'Die Instanz der Analysefunktion
    Private m_cSLDFilename As String   'Der Dateiname der SLD
    Private m_cSLDTempFilename As String    'Der vorlufige Dateiname aus der Config.-XML
    Private m_cXSDFilename As String    'der Dateiname der Schemadatei
    Private m_objCommonXML As New CommonXMLHandle   'Instanz des "einfachen" XML-Handle
    Private m_ScaleAl As ArrayList  'Die Arraylist mit den Mastabseintrgen
    Private m_cHighScale As String    'Der aktuelle Text der rechten Combobox
    Private m_cLowScale As String     'Der aktuelle Text der linken Combobox

    Private m_bLabel As Boolean '????
    Private m_bTooltip As Boolean   'Tooltips an/aus
    Friend m_bAllLayers As Boolean 'All layers processed or not
    Friend m_enumLang As Language  'die Sprache

    'Die Variablen fr die Steuerelementnamen
    Private m_text_eng_Label3 As String
    Private m_text_eng_Label4 As String
    Private m_text_eng_Label5 As String
    Private m_text_eng_Label6 As String
    Private m_text_ger_Label3 As String
    Private m_text_ger_Label4 As String
    Private m_text_ger_Label5 As String
    Private m_text_ger_Label6 As String

    Private m_ttip_eng_Label3 As String
    Private m_ttip_eng_Label4 As String
    Private m_ttip_eng_Label5 As String
    Private m_ttip_eng_Label6 As String
    Private m_ttip_ger_Label3 As String
    Private m_ttip_ger_Label4 As String
    Private m_ttip_ger_Label5 As String
    Private m_ttip_ger_Label6 As String
    '___________________________________________

    Private m_text_eng_GroupBox1 As String
    Private m_text_eng_GroupBox2 As String
    Private m_text_eng_GroupBox3 As String
    Private m_text_ger_GroupBox1 As String
    Private m_text_ger_GroupBox2 As String
    Private m_text_ger_GroupBox3 As String

    Private m_ttip_eng_GroupBox1 As String
    Private m_ttip_eng_GroupBox2 As String
    Private m_ttip_eng_GroupBox3 As String
    Private m_ttip_ger_GroupBox1 As String
    Private m_ttip_ger_GroupBox2 As String
    Private m_ttip_ger_GroupBox3 As String
    '___________________________________________

    Private m_text_eng_chkArcIMS As String
    Private m_text_eng_chkUMN As String
    Private m_text_ger_chkArcIMS As String
    Private m_text_ger_chkUMN As String

    Private m_ttip_eng_chkArcIMS As String
    Private m_ttip_eng_chkUMN As String
    Private m_ttip_ger_chkArcIMS As String
    Private m_ttip_ger_chkUMN As String


    Private m_text_eng_chkValidate As String
    Private m_text_ger_chkValidate As String

    Private m_ttip_eng_chkValidate As String
    Private m_ttip_ger_chkValidate As String
    '___________________________________________

    Private m_text_eng_Button1 As String
    Private m_text_ger_Button1 As String

    Private m_ttip_eng_Button1 As String
    Private m_ttip_ger_Button1 As String


    '##################################################################################################
    '######################################## ENUMERATIONEN ###########################################
    '##################################################################################################

#Region "Enums"

    'Die Sprache
    Friend Enum Language
        Deutsch = 0
        English = 1
    End Enum

#End Region




#End Region

    '##################################################################################################
    '######################################### FUNKTIONEN #############################################
    '##################################################################################################
#Region "Funktionen"
    'Einfacher Sortieralgorithmus fr stringinhalte
    Private Function SortMe(ByVal al As ArrayList) As ArrayList
        Dim al2 As New ArrayList
        Dim cStoreString As String
        Dim i, iTmpDigit As Int16

        Try
            Do Until al.Count = 1
                cStoreString = al(0)
                iTmpDigit = 0
                For i = 1 To al.Count - 1
                    If CInt(cStoreString) > CInt(al(i)) Then
                        cStoreString = al(i).ToString
                        iTmpDigit = i
                    End If
                Next
                al2.Add(cStoreString)
                al.RemoveAt(iTmpDigit)
            Loop
            al2.Add(al(0))
            Return al2
        Catch ex As Exception
            MessageBox.Show("Uuuhps " & ex.Message)
        End Try

    End Function
#End Region

    '##################################################################################################
    '########################################### ROUTINEN #############################################
    '##################################################################################################
#Region "Routinen"
    Public Sub CHLabelBottom(ByVal value As String)
        Me.lblBottom.Text = value
        Me.Refresh()
    End Sub

    Public Sub CHLabelTop(ByVal value As String)
        Me.lblTop.Text = value
        Me.Refresh()
    End Sub

    Public Sub CHLabelSmall(ByVal value As String)
        Me.lblSmall.Text = value
        Me.Refresh()
    End Sub

    Friend Sub MinimizeWindow()
        Dim dCurrentTime As Date
        dCurrentTime = DateTime.Today.Now
        Dim dTargetTime As Date
        dTargetTime = dCurrentTime.AddSeconds(5)

        Do While dCurrentTime < dTargetTime
            dCurrentTime = DateTime.Today.Now
        Loop
        Me.CHLabelSmall("")
        Me.CHLabelBottom("")
        Me.CHLabelTop("")
        SetSizeClose()
    End Sub

    Friend Sub MinimizeWindow2()
        Me.CHLabelSmall("")
        Me.CHLabelBottom("")
        Me.CHLabelTop("")
        SetSizeClose()
    End Sub

    Private Sub SetSizeOpen()
        Me.Height = 232
        GroupBox2.Height = 24
    End Sub

    Private Sub SetSizeClose()
        Me.Height = 252
        GroupBox2.Height = 24
    End Sub

    Public Sub MyTermination()
        Me.Close()
        Me.Dispose()
        End
        'oder: application.exit
    End Sub

    Public Sub DoEvents()
        Application.DoEvents()
    End Sub

    '************************************************************************************************
    'Initialisiert das Commmon XML-Handle                                                           *
    '************************************************************************************************
    Private Sub InitCommonXML()

        Try
            m_objCommonXML.XMLfilename = AppDomain.CurrentDomain.BaseDirectory & "Preconfigure_Converter.xml"
            If m_objCommonXML.OpenDoc() = True Then

            Else
                If m_enumLang = Language.Deutsch Then
                    InfoMsg("Die Konfigurationsdatei Preconfigure_Converter.xml wurde nicht im Anwendungsverzeichnis gefunden." & _
" Bitte stellen Sie eine aktuelle Preconfigure_Converter.xml in das Anwendungsverzeichnis und starten SIe die Anwendung erneut." & vbCrLf, "Preconfigure")
                    MyTermination()
                ElseIf m_enumLang = Language.English Then
                    InfoMsg("The Configuration-file Preconfigure_Converter.xml wasn't found at the application home-directory." & _
" please copy a Preconfigure_Converter.xml to the application home-directory and restart the application." & vbCrLf, "Preconfigure")
                    MyTermination()
                End If

            End If
        Catch ex As Exception
            ErrorMsg("Fehler beim Einlesen der Vorkonfigurations-XML-Datei" & vbCrLf, ex.Message, "InitCommonXML")
            MyTermination()
        End Try
    End Sub

    '************************************************************************************************
    'Initialisiert die Steuerelementnamens-Variablen*
    '************************************************************************************************
    Private Sub InitControlNameVariables()

        Try
            If m_objCommonXML.FindRoot("preconfigure") = True Then
                If m_objCommonXML.FindSection("Label3") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Label3 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Label3 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Label3 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Label3 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("Label4") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Label4 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Label4 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Label4 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Label4 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("Label5") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Label5 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Label5 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Label5 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Label5 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("Label5") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Label5 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Label5 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Label5 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Label5 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("Label6") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Label6 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Label6 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Label6 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Label6 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("GroupBox1") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_GroupBox1 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_GroupBox1 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_GroupBox1 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_GroupBox1 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("GroupBox2") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_GroupBox2 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_GroupBox2 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_GroupBox2 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_GroupBox2 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("GroupBox2") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_GroupBox2 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_GroupBox2 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_GroupBox2 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_GroupBox2 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("GroupBox3") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_GroupBox3 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_GroupBox3 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_GroupBox3 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_GroupBox3 = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("chkArcIMS") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_chkArcIMS = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_chkArcIMS = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_chkArcIMS = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_chkArcIMS = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("chkUMN") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_chkUMN = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_chkUMN = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_chkUMN = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_chkUMN = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("chkValidate") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_chkValidate = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_chkValidate = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_chkValidate = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_chkValidate = m_objCommonXML.GetSubentryValue
                End If
                If m_objCommonXML.FindSection("Button1") = True Then
                    m_objCommonXML.FindEntry("english")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_eng_Button1 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_eng_Button1 = m_objCommonXML.GetSubentryValue

                    m_objCommonXML.FindEntry("deutsch")
                    m_objCommonXML.FindSubEntry("text")
                    m_text_ger_Button1 = m_objCommonXML.GetSubentryValue
                    m_objCommonXML.FindSubEntry("tooltip")
                    m_ttip_ger_Button1 = m_objCommonXML.GetSubentryValue
                End If
            End If
        Catch ex As Exception
            ErrorMsg("Die Elemente in der Vorkonfigurations-XML-Datei sind nicht korrekt." & vbCrLf, ex.Message, "InitControlNameVariables")

        End Try
    End Sub

    '************************************************************************************************
    'Die Initialisierung der Steuerelemente auf Englisch*
    '************************************************************************************************
    Private Sub InitControlsEnglish()
        Me.Label3.Text = m_text_eng_Label3
        Me.Label4.Text = m_text_eng_Label4
        Me.Label5.Text = m_text_eng_Label5
        Me.Label6.Text = m_text_eng_Label6
        Me.GroupBox1.Text = m_text_eng_GroupBox1
        Me.GroupBox2.Text = m_text_eng_GroupBox2
        Me.GroupBox3.Text = m_text_eng_GroupBox3
        Me.chkArcIMS.Text = m_text_eng_chkArcIMS
        Me.chkUMN.Text = m_text_eng_chkUMN
        Me.chkValidate.Text = m_text_eng_chkValidate
        Me.Button1.Text = m_text_eng_Button1
    End Sub

    '************************************************************************************************
    'Die Initialisierung der Steuerelemente auf Deutsch*
    '************************************************************************************************
    Private Sub InitControlsGerman()
        Me.Label3.Text = m_text_ger_Label3
        Me.Label4.Text = m_text_ger_Label4
        Me.Label5.Text = m_text_ger_Label5
        Me.Label6.Text = m_text_ger_Label6
        Me.GroupBox1.Text = m_text_ger_GroupBox1
        Me.GroupBox2.Text = m_text_ger_GroupBox2
        Me.GroupBox3.Text = m_text_ger_GroupBox3
        Me.chkArcIMS.Text = m_text_ger_chkArcIMS
        Me.chkUMN.Text = m_text_ger_chkUMN
        Me.chkValidate.Text = m_text_ger_chkValidate
        Me.Button1.Text = m_text_ger_Button1
    End Sub

    '************************************************************************************************
    'Die Initialisierung der Steuerelemente mit Tooltips*
    '************************************************************************************************
    Private Sub InitTooltips()

        If Me.m_enumLang = Language.Deutsch Then
            Me.ToolTip1.SetToolTip(Me.Label3, m_ttip_ger_Label3)
            Me.ToolTip1.SetToolTip(Me.Label4, m_ttip_ger_Label4)
            Me.ToolTip1.SetToolTip(Me.Label5, m_ttip_ger_Label5)
            Me.ToolTip1.SetToolTip(Me.Label6, m_ttip_ger_Label6)
            Me.ToolTip1.SetToolTip(Me.GroupBox1, m_ttip_ger_GroupBox1)
            Me.ToolTip1.SetToolTip(Me.GroupBox2, m_ttip_ger_GroupBox2)
            Me.ToolTip1.SetToolTip(Me.GroupBox3, m_ttip_ger_GroupBox3)
            Me.ToolTip1.SetToolTip(Me.chkArcIMS, m_ttip_ger_chkArcIMS)
            Me.ToolTip1.SetToolTip(Me.chkUMN, m_ttip_ger_chkUMN)
            Me.ToolTip1.SetToolTip(Me.chkValidate, m_ttip_ger_chkValidate)
            Me.ToolTip1.SetToolTip(Me.Button1, m_ttip_ger_Button1)
        ElseIf Me.m_enumLang = Language.English Then
            Me.ToolTip1.SetToolTip(Me.Label3, m_ttip_eng_Label3)
            Me.ToolTip1.SetToolTip(Me.Label4, m_ttip_eng_Label4)
            Me.ToolTip1.SetToolTip(Me.Label5, m_ttip_eng_Label5)
            Me.ToolTip1.SetToolTip(Me.Label6, m_ttip_eng_Label6)
            Me.ToolTip1.SetToolTip(Me.GroupBox1, m_ttip_eng_GroupBox1)
            Me.ToolTip1.SetToolTip(Me.GroupBox2, m_ttip_eng_GroupBox2)
            Me.ToolTip1.SetToolTip(Me.GroupBox3, m_ttip_eng_GroupBox3)
            Me.ToolTip1.SetToolTip(Me.chkArcIMS, m_ttip_eng_chkArcIMS)
            Me.ToolTip1.SetToolTip(Me.chkUMN, m_ttip_eng_chkUMN)
            Me.ToolTip1.SetToolTip(Me.chkValidate, m_ttip_eng_chkValidate)
            Me.ToolTip1.SetToolTip(Me.Button1, m_ttip_eng_Button1)
        End If

    End Sub

    '************************************************************************************************
    'Liest die Daten fr die Vorkonfiguration des Formulars aus der XML (i.A. Die Scales-Comboboxen)*
    '************************************************************************************************
    Private Sub Preconfigure()
        Dim i As Int16
        Dim alTmp As ArrayList

        Try
            If m_objCommonXML.FindRoot("preconfigure") = True Then
                'Ab hier die Mastbe
                If m_objCommonXML.FindSection("scales") = True Then
                    m_ScaleAl = m_objCommonXML.GetAllEntryValues
                End If
            End If

            alTmp = SortMe(m_ScaleAl)
            m_ScaleAl = Nothing
            m_ScaleAl = alTmp
            cboLowScale.Items.Clear()
            cboHighScale.Items.Clear()
            For i = 0 To m_ScaleAl.Count - 1
                cboLowScale.Items.Add(m_ScaleAl(i))
                cboHighScale.Items.Add(m_ScaleAl(i))
            Next
            cboLowScale.Text = cboLowScale.Items.Item(0)
            cboHighScale.Text = cboLowScale.Items.Item(m_ScaleAl.Count - 1)

            'Ab hier der SLD-Dateipfad/Name
            If m_objCommonXML.FindSection("SLDFilename") = True Then
                m_cSLDTempFilename = m_objCommonXML.getSectionValue
            End If

            'Ab hier die Checkbox Scales
            If m_objCommonXML.FindSection("Checkboxes") = True Then
                If m_objCommonXML.FindEntry("chkScale") = True Then
                    If m_objCommonXML.getEntryValue.ToUpper = "true".ToUpper Then
                        chkScale.Checked = True
                    ElseIf m_objCommonXML.getEntryValue.ToUpper = "false".ToUpper Then
                        chkScale.Checked = False
                    Else
                        chkScale.Checked = False
                    End If
                End If
            End If

            'ab hier werden die Labelnamen auf Englisch/Deutsch ausgelesen


        Catch ex As Exception
            ErrorMsg("Fehler beim Einlesen der Vorkonfigurations-XML-Datei" & vbCrLf, ex.Message, "Preconfiguration")
            MyTermination()
        End Try
    End Sub

    '************************************************************************************************
    'Schreibt die letzten Benutzereinstellungen zurck in die Preconfigure_Converter.xml
    '************************************************************************************************
    Friend Sub ReadBackValues()

        Try
            'Ab hier der SLD-Dateipfad/Name
            If m_objCommonXML.FindSection("SLDFilename") = True Then
                m_objCommonXML.SetSectionValue(txtFileName.Text)
            End If
            'Ab hier die Checkbox Scales
            If m_objCommonXML.FindSection("Checkboxes") = True Then
                If m_objCommonXML.FindEntry("chkScale") = True Then
                    If chkScale.Checked = True Then
                        m_objCommonXML.SetEntryValue("true")
                    Else
                        m_objCommonXML.SetEntryValue("false")
                    End If
                End If
            End If
        Catch ex As Exception
            ErrorMsg("Fehler beim Auslesen in die Vorkonfigurations-XML-Datei" & vbCrLf, ex.Message, "ReadBackValues")
            MyTermination()
        End Try
    End Sub

    '************************************************************************************************
    '**********************Liest die Scales-Daten aus der XML erneut in die Comboboxen***************
    '************************************************************************************************
    Private Sub LoadCboScalesNew()
        Dim cHighScale, cLowScale As String
        Dim i As Int16
        Dim alTmp As ArrayList
        cHighScale = cboHighScale.Text
        cLowScale = cboLowScale.Text

        Try
            If m_objCommonXML.FindRoot("preconfigure") = True Then
                If m_objCommonXML.FindSection("scales") = True Then
                    m_ScaleAl = m_objCommonXML.GetAllEntryValues
                End If
            End If
            alTmp = SortMe(m_ScaleAl)
            m_ScaleAl = Nothing
            m_ScaleAl = alTmp
            cboLowScale.Items.Clear()
            cboHighScale.Items.Clear()
            For i = 0 To m_ScaleAl.Count - 1
                cboLowScale.Items.Add(m_ScaleAl(i))
                cboHighScale.Items.Add(m_ScaleAl(i))
            Next
            cboLowScale.Text = cLowScale
            cboHighScale.Text = cHighScale
        Catch ex As Exception
            ErrorMsg("Fehler beim Einlesen der Vorkonfigurations-XML-Datei", ex.Message, "Preconfiguration")
        End Try
    End Sub



    '************************************************************************************************
    '********************************* Die zentrale Fehlermeldung ***********************************
    '************************************************************************************************
    Private Sub ErrorMsg(ByVal Message As String, ByVal ExMessage As String, ByVal FunctionName As String)
        MessageBox.Show(Message & vbCrLf & ExMessage, "ArcGIS_SLD_Converter | Analize_ArcMap_Symbols | " & FunctionName, MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    '************************************************************************************************
    '********************************* Die zentrale Infomeldung ***********************************
    '************************************************************************************************
    Private Sub InfoMsg(ByVal message As String, ByVal functionname As String)
        MessageBox.Show(message, "Analize_ArcMap_Symbols | Output_SLD | " & functionname, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End Sub

    '************************************************************************************************
    'zeigt das Wartesymbol an
    '************************************************************************************************
    Friend Sub ShowWorld()
        PictureBox1.Visible = True
        PictureBox1.Refresh()
        Me.Refresh()
    End Sub

    '************************************************************************************************
    'zeigt das Wartesymbol an
    '************************************************************************************************
    Friend Sub HideWorld()
        PictureBox1.Visible = False
    End Sub
#End Region

    '##################################################################################################
    '######################################### PROPERTIES #############################################
    '##################################################################################################
#Region "Properties"
    Public ReadOnly Property GetSLDFilename() As String
        Get
            Return m_cSLDFilename
        End Get
    End Property

    Public ReadOnly Property GetXSDFilename() As String
        Get
            Return m_cXSDFilename
        End Get
    End Property

    Public ReadOnly Property GetSLDFileFromConfigXML() As String
        Get
            Return m_cSLDTempFilename
        End Get
    End Property
#End Region

    '##################################################################################################
    '############################################# EVENTS #############################################
    '##################################################################################################
#Region "Events"
    'Der SLD-Button stt die Analyse an
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Die Gre von Formular und Infofeld wird gendert
        Me.Height = 324
        Me.GroupBox2.Height = 96
        'Hier noch die berprfung, ob Ober und Untergrenze des Mastabs korrekt gewhlt wurden
        If Me.chkScale.Checked = True Then
            If CInt(Me.cboHighScale.Text) < CInt(Me.cboLowScale.Text) Then
                Dim cTmp As String
                cTmp = cboHighScale.Text
                cboHighScale.Text = cboLowScale.Text
                cboLowScale.Text = cTmp
            End If
        End If
        'Die Analyse wird gestartet
        AnalizeArcMap = New Analize_ArcMap_Symbols(Me, m_cSLDFilename)
        If Me.chkValidate.Checked = False Then
            MinimizeWindow()
        End If
        If Me.lblSmall.Text = "Die SLD ist gltig" Then
            MinimizeWindow()
        End If
    End Sub

    'Der SLD speichern unter Button
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim swOutput As IO.StreamWriter
        Dim oFile As File

        If oFile.Exists(Me.GetSLDFileFromConfigXML) Then
            Me.dlgSave.InitialDirectory = Me.GetSLDFileFromConfigXML
        End If
        With dlgSave
            .CheckFileExists = False
            .CheckPathExists = True
            .DefaultExt = "sld"
            .Filter = "SLD-Dateien (*.sld)|*.sld"
            .AddExtension = True
            .OverwritePrompt = True
            .CreatePrompt = False
            If .ShowDialog() = DialogResult.OK Then
                m_cSLDFilename = .FileName
                txtFileName.Text = m_cSLDFilename
            End If
        End With
    End Sub

    'das Validierungsoptionsfeld
    Private Sub chkValidate_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkValidate.CheckedChanged
        If chkValidate.Checked = True Then
            txtSLDxsd.Visible = True
            With OpenXSD
                .CheckFileExists = False
                .CheckPathExists = True
                .Filter = "Schemadateien (*.xsd)|*.xsd"
                .InitialDirectory = IO.Path.GetDirectoryName(m_cSLDFilename)
                If .ShowDialog() = DialogResult.OK Then
                    m_cXSDFilename = .FileName
                    txtSLDxsd.Text = m_cXSDFilename
                Else
                    m_cXSDFilename = ""
                    chkValidate.Checked = False
                    txtSLDxsd.Visible = False
                    Exit Sub
                End If
            End With
        Else
            txtSLDxsd.Visible = False
        End If
    End Sub



    '############################################################################################################
    'Die folgenden Ereignisse beziehen sich alle auf die Mastabscomboboxen
    '############################################################################################################

    'Die berprfung, da auch nur Zahlen in Comboboxfeld eingegeben werden. Wenn Zahl noch nicht in XML-
    'datei enthalten, wird sie bernommen in XML-Datei
    Private Sub cboHighScale_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboHighScale.Leave
        Dim i, j As Int16
        Dim bIsNumber As Boolean = True
        Dim cComboText As String
        cComboText = cboHighScale.Text

        Try
            For j = 0 To cComboText.Length - 1
                If Not (cComboText.Chars(j) = "0" Or cComboText.Chars(j) = "1" Or cComboText.Chars(j) = "2" Or cComboText.Chars(j) = "3" Or cComboText.Chars(j) = "4" Or cComboText.Chars(j) = "5" Or cComboText.Chars(j) = "6" Or cComboText.Chars(j) = "7" Or cComboText.Chars(j) = "8" Or cComboText.Chars(j) = "9") Then
                    If m_enumLang = Language.Deutsch Then
                        MessageBox.Show("Bitte geben Sie nur ZAHLEN ohne Komma zwischen 10 und 100000000 in das Textfeld ein!", Nothing, MessageBoxButtons.OK, MessageBoxIcon.Information)
                    ElseIf m_enumLang = Language.English Then
                        MessageBox.Show("Please insert only NUMBERS between 10 und 100000000 into the text field!", Nothing, MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                    cboHighScale.Text = m_cHighScale
                    bIsNumber = False
                    Exit Sub
                End If
            Next
            If bIsNumber = True Then
                If Not m_ScaleAl.Contains(cboHighScale.Text) Then
                    'Hier die Aufnahme in die Datei Preconfigure_Converter.xml
                    m_objCommonXML.FindSection("scales")
                    m_objCommonXML.CreateEntry("scale")
                    m_objCommonXML.SetEntryValue(cboHighScale.Text)
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("Unbekannter Fehler." & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub


    'Die berprfung, da auch nur Zahlen in Comboboxfeld eingegeben werden. Wenn Zahl noch nicht in XML-
    'datei enthalten, wird sie bernommen in XML-Datei
    Private Sub cboLowScale_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboLowScale.Leave
        Dim i, j As Int16
        Dim bIsNumber As Boolean = True
        Dim cComboText As String
        cComboText = cboLowScale.Text

        Try
            For j = 0 To cComboText.Length - 1
                If Not (cComboText.Chars(j) = "0" Or cComboText.Chars(j) = "1" Or cComboText.Chars(j) = "2" Or cComboText.Chars(j) = "3" Or cComboText.Chars(j) = "4" Or cComboText.Chars(j) = "5" Or cComboText.Chars(j) = "6" Or cComboText.Chars(j) = "7" Or cComboText.Chars(j) = "8" Or cComboText.Chars(j) = "9") Then
                    If m_enumLang = Language.Deutsch Then
                        MessageBox.Show("Bitte geben Sie nur ZAHLEN ohne Komma zwischen 10 und 100000000 in das Textfeld ein!", Nothing, MessageBoxButtons.OK, MessageBoxIcon.Information)
                    ElseIf m_enumLang = Language.English Then
                        MessageBox.Show("Please insert only NUMBERS between 10 und 100000000 into the text field!", Nothing, MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                    cboLowScale.Text = m_cLowScale
                    bIsNumber = False
                    Exit Sub
                End If
            Next
            If bIsNumber = True Then
                If Not m_ScaleAl.Contains(cboLowScale.Text) Then
                    'Hier die Aufnahme in die Datei Preconfigure_Converter.xml
                    m_objCommonXML.FindSection("scales")
                    m_objCommonXML.CreateEntry("scale")
                    m_objCommonXML.SetEntryValue(cboLowScale.Text)
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("Unbekannter Fehler." & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub

    Private Sub cboHighScale_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboHighScale.Enter
        m_cHighScale = cboHighScale.Text
    End Sub

    Private Sub cboLowScale_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboLowScale.Enter
        m_cLowScale = cboLowScale.Text
    End Sub

    Private Sub cboHighScale_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboHighScale.DropDown
        LoadCboScalesNew()
    End Sub

    Private Sub cboLowScale_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboLowScale.DropDown
        LoadCboScalesNew()
    End Sub

    '############################################################################################################
    'Die folgenden Ereignisse beziehen sich alle auf die Menleiste
    '############################################################################################################


    'Men: Deutsch
    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        InitControlsGerman()
        Me.m_enumLang = Language.Deutsch
        InitTooltips()
    End Sub

    'Men: English
    Private Sub MenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem4.Click
        InitControlsEnglish()
        Me.m_enumLang = Language.English
        InitTooltips()
    End Sub

    'Men: Tooltips
    Private Sub MenuItem6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem6.Click
        If m_bTooltip = False Then
            InitTooltips()
            ToolTip1.Active = True
            MenuItem6.Text = "aus/off"
            m_bTooltip = True
        Else
            ToolTip1.Active = False
            MenuItem6.Text = "ein/on"
            m_bTooltip = False
        End If
    End Sub

    'Men: Layers All
    Private Sub MenuItem8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem8.Click
        m_bAllLayers = True
        MenuItem8.Checked = True
        MenuItem9.Checked = False
    End Sub

    'Men: Layers Selected
    Private Sub MenuItem9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem9.Click
        m_bAllLayers = False
        MenuItem8.Checked = False
        MenuItem9.Checked = True
    End Sub



    'Beim Schlieen der Anwendung werden die Werte zurckgeschrieben in die Datei PreconfigureConverter
    Private Sub Motherform_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ReadBackValues()
    End Sub
#End Region

 
    Private Sub Motherform_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
