'####################################################################################################################
'*******************ArcGIS_SLD_Converter / Rel. 1.2.0****************************************************************
'*******************Class: Validation Message************************************************************************
'*******************AUTHOR: Albrecht Weiser, University of applied Sciences in Mainz, Germany 2005*******************
'The Application was part of my Diploma thesis:**********************************************************************
'"Transforming map-properties of maps in esri-data to an OGC-conformous SLD-document, for publishing the ArcGIS-map * 
'with an OGC- conformous map-server"*********************************************************************************
'ABSTRACT:
'The program so called "ArcGIS-map to SLD Converter" analyses an
'ArcMap-Project with respect to its symbolisation and assembles an SLD
'for the OGC-Web Map Service (WMS) from the gathered data. The program
'is started parallel to a running ArcMap 9.X-session. Subsequently the
'application deposits an SLD-file which complies the symbolisation of
'the available ArcMap-project. With the SLD a WMS-project may be
'classified and styled according to the preceding ArcMap-project. The
'application is written in VisualBasic.NET and uses the .NET 1.1
'Framework (plus XML files for configuration). For more informtion
'refer to: 
'http://arcmap2sld.geoinform.fh-mainz.de/ArcMap2SLDConverter_Eng.htm.
'LICENSE:
'This program is free software under the license of the GNU Lesser General Public License (LGPL) As published by the Free Software Foundation. 
'With the use and further development of this code you accept the terms of LGPL. For questions of the License refer to:
'http://www.gnu.org/licenses/lgpl.html
'DISCLAIMER:
'THE USE OF THE SOFTWARE ArcGIS-map to SLD Converter HAPPENS AT OWN RISK.
'I CANNOT ISSUE A GUARANTEE FOR ANY DISADVANTAGES (INCLUDING LOSS OF DATA; ETC.) THAT
'MAY ARISE FROM USING THIS SOFTWARE.
'DESCRIPTION:
'It displays the messages coming from the class ValidateSLD
'CHANGES:
'####################################################################################################################

Imports System.IO
Public Class Validation_Message
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New(ByVal ValidMessage As String, ByVal mother As Motherform)
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        m_cValidationMessage = ValidMessage
        Me.txtValidMessage.Text = m_cValidationMessage
        frmMotherform = mother

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents txtValidMessage As System.Windows.Forms.RichTextBox
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents dlgSave As System.Windows.Forms.SaveFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtValidMessage = New System.Windows.Forms.RichTextBox
        Me.btnSave = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.dlgSave = New System.Windows.Forms.SaveFileDialog
        Me.SuspendLayout()
        '
        'txtValidMessage
        '
        Me.txtValidMessage.Location = New System.Drawing.Point(0, 0)
        Me.txtValidMessage.Name = "txtValidMessage"
        Me.txtValidMessage.Size = New System.Drawing.Size(448, 216)
        Me.txtValidMessage.TabIndex = 0
        Me.txtValidMessage.Text = ""
        '
        'btnSave
        '
        Me.btnSave.Location = New System.Drawing.Point(168, 224)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(24, 16)
        Me.btnSave.TabIndex = 1
        Me.btnSave.Text = "..."
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 224)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(160, 16)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "Speichern der Nachricht unter"
        '
        'Validation_Message
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(450, 244)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.btnSave)
        Me.Controls.Add(Me.txtValidMessage)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
        Me.Name = "Validation_Message"
        Me.Text = "Nachricht der Gltigkeitsberprfung"
        Me.TopMost = True
        Me.ResumeLayout(False)

    End Sub

#End Region

    '##################################################################################################
    '######################################## DEKLARATIONEN ###########################################
    '##################################################################################################
    Private m_cValidationMessage As String
    Private m_cMessageFilename As String
    Private frmMotherform As Motherform


    '##################################################################################################
    '########################################### ROUTINEN #############################################
    '##################################################################################################


    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Try
            With dlgSave
                .CheckFileExists = False
                .CheckPathExists = True
                .DefaultExt = "txt"
                .Filter = "Textdateien (*.txt)|*.txt"
                .AddExtension = True
                .InitialDirectory = IO.Path.GetDirectoryName(m_cMessageFilename)
                .OverwritePrompt = True
                .CreatePrompt = False
                If .ShowDialog() = DialogResult.OK Then
                    m_cMessageFilename = .FileName
                End If
            End With
            NewTextFile()
        Catch ex As Exception
            MessageBox.Show("Fehler beim speichern der Textdatei fr die Gltigkeits-berprfung")
            End
        End Try
        Me.Close()
        Me.Dispose()
    End Sub

    '##################################################################################################
    '######################################### FUNKTIONEN #############################################
    '##################################################################################################

    '************************************************************************************************
    'Die Funktion schreibt die Fehlermeldung in eine Textdatei
    '************************************************************************************************
    Private Function NewTextFile()
        Dim objFile As FileStream
        Dim objWriter As StreamWriter
        Dim tempArray() As String
        Dim i As Integer

        Try
            objFile = File.OpenWrite(m_cMessageFilename)
            objWriter = New StreamWriter(objFile)
            tempArray = txtValidMessage.Lines
            For i = 0 To tempArray.GetUpperBound(0)
                objWriter.WriteLine(tempArray(i))
            Next
        Catch ex As Exception
            MessageBox.Show("Fehler beim speichern der Textdatei fr die Gltigkeits-berprfung")
        Finally
            objWriter.Close()
            objFile.Close()
        End Try
    End Function


    '##################################################################################################
    '############################################# EVENTS #############################################
    '##################################################################################################

    Private Sub Validation_Message_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        frmMotherform.MinimizeWindow2()
    End Sub

    Private Sub Validation_Message_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
